<mat-card class="manage-employee-wrapper">
  <div class="filter-wrapper">
    <h2>EMPLOYEE ({{ employeeData.length }})</h2>
    <button mat-raised-button (click)="navigateToApplication()">
      Create Employee
    </button>
  </div>

  <table mat-table [dataSource]="dataSource">
    <!-- Employee ID Column -->
    <ng-container matColumnDef="employeeid">
      <th mat-header-cell *matHeaderCellDef>Employee ID</th>
      <td mat-cell *matCellDef="let element">{{ element.employeeid }}</td>
      <td mat-footer-cell *matFooterCellDef>Total Provident Fund</td>
    </ng-container>

    <!-- First Name Column -->
    <ng-container matColumnDef="firstname">
      <th mat-header-cell *matHeaderCellDef>First Name</th>
      <td mat-cell *matCellDef="let element">{{ element.firstname }}</td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Last Name Column -->
    <ng-container matColumnDef="lastname">
      <th mat-header-cell *matHeaderCellDef>Last Name</th>
      <td mat-cell *matCellDef="let element">{{ element.lastname }}</td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Birth Date Column -->
    <ng-container matColumnDef="birthdate">
      <th mat-header-cell *matHeaderCellDef>Birth Date</th>
      <td mat-cell *matCellDef="let element">{{ element.birthdate }}</td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Age Column -->
    <ng-container matColumnDef="age">
      <th mat-header-cell *matHeaderCellDef>Age</th>
      <td mat-cell *matCellDef="let element">
        {{ getAge(element) }}
      </td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Start Date Column -->
    <ng-container matColumnDef="startdate">
      <th mat-header-cell *matHeaderCellDef>Start Date</th>
      <td mat-cell *matCellDef="let element">{{ element.startdate }}</td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Employee Type Column -->
    <ng-container matColumnDef="employeetype">
      <th mat-header-cell *matHeaderCellDef>Employee Type</th>
      <td mat-cell *matCellDef="let element">{{ element.employeetype }}</td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Salary Column -->
    <ng-container matColumnDef="salary">
      <th mat-header-cell *matHeaderCellDef>Salary</th>
      <td mat-cell *matCellDef="let element">
        {{ element.salary | currency: "฿" }}
      </td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Provident Fund Rate Column -->
    <ng-container matColumnDef="pvfrate">
      <th mat-header-cell *matHeaderCellDef>Provident Fund Rate</th>
      <td mat-cell *matCellDef="let element">{{ element.pvfrate }}</td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Cost Column -->
    <ng-container matColumnDef="pvftotal">
      <th mat-header-cell *matHeaderCellDef>Provident Fund Total</th>
      <td mat-cell *matCellDef="let element">
        {{ getEmployeeTotalProvidentFund(element) | currency: "฿" }}
      </td>
      <td mat-footer-cell *matFooterCellDef>
        {{ getTotalProvidentFund() | currency: "฿" }}
      </td>
    </ng-container>

    <!-- Leave Status Column -->
    <ng-container matColumnDef="leavestatus">
      <th mat-header-cell *matHeaderCellDef>Leave Status</th>
      <td mat-cell *matCellDef="let element" class="leave-status">
        {{ element.leavestatus ? "L" : "" }}
      </td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Update Column -->
    <ng-container matColumnDef="edit" stickyEnd>
      <th mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let element">
        <button
          mat-icon-button
          class="update-icon"
          (click)="navigateToApplication(element.employeeid)"
        >
          <mat-icon>create</mat-icon>
        </button>
      </td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <!-- Leave Column -->
    <ng-container matColumnDef="delete" stickyEnd>
      <th mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let element">
        <button
          mat-icon-button
          class="remove-icon"
          aria-label="Example icon-button with a heart icon"
          (click)="openConfirmDialog(element)"
        >
          <mat-icon>delete_sweep</mat-icon>
        </button>
      </td>
      <td mat-footer-cell *matFooterCellDef></td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
    <tr
      mat-row
      (click)="clickedRows.add(row)"
      [class.demo-row-is-clicked]="clickedRows.has(row)"
      *matRowDef="let row; columns: displayedColumns"
    ></tr>
    <tr mat-footer-row *matFooterRowDef="displayedColumns"></tr>
  </table>

  <mat-paginator
    [pageSizeOptions]="[10, 25, 50, 100]"
    showFirstLastButtons
    aria-label="Select page of periodic elements"
  >
  </mat-paginator>
</mat-card>
